%% rizeni N vozidel
clc; clear all; close all;
N = 5;  % pocet vozidel
pocet_stavu = 2*N-1;    % vypocte pocet stavu v modelu
conds = [0 , 4 , 0 , 2 , 0];
if N == 5
    conds = [0 , 4 , 0 , 2 , 0, 1, 0, -1, 0];
end
conds0 = zeros(1,2*N-1);    % nulove poc. podminky

% automaticky matice A,B
A = zeros(2*N-1);
B = zeros(2*N-1,N);

for i = 1:2:(2*N-1)
   A(i,i) = -1;
   A(i+1,i) = 1;
   A(i+1,i+2) = -1;
end
for i = 1:2:(2*N-1)
    B(i,ceil(i/2)) = 1;
end
A = A(1:(2*N-1),1:(2*N-1));
C = eye(pocet_stavu);
Cy = C;
Cw = C;
Cy(2:2:pocet_stavu-1,2:2:pocet_stavu-1) = 0;
Cw(1:2:pocet_stavu,1:2:pocet_stavu) = 0;
D = zeros(pocet_stavu,N);

s = tf('s');
prenosy =(C*(s*eye(pocet_stavu)-A)^(-1)*B);     % prenosy nerizeneho systemu
qs = 4;
ql = 2;

Q = eye(pocet_stavu)*ql;   % nastaveni vahove matice stavu Q

Q(2,2) = qs;
% Q(3,3) = 1;
Q(4,4) = qs;
% Q(5,5) = 1;
if N > 3
Q(6,6) = qs;
% Q(7,7) = 1;    
    if N == 5
        Q(8,8) = qs;
%         Q(9,9) = 1;        
    end
end

R = eye(N);         % nastaveni vahove matice vstupu R
[K,~,~] = lqr(A,B,Q,R);     % vypocet matice zesileni pomoci LQR

Az = A-B*K;     % dynamika rizeneho systemu
eig(Az) % vlastni cisla rizeneho systemu
porucha = B; 

% prenosy pro aktualni Q a R
Fc = simplify(C*((s*eye(pocet_stavu)-Az)^(-1))*porucha + D);    % prenosy rizeneho systemu

H = zeros(1,N-2);    
% podminka retezove stability
a=1:2*N-1;
sude=a(mod(a,2)==0);    % sude prenosy odpovidaji z poruchy na odchylky poloh
for i=1:N-2       % pro mozne vozidla  
H(i) = norm((Fc(sude(i+1),i)/Fc(sude(i),i)),Inf);  % pomer jednotlivych prenosu z poruchy na odchylku od poloh
end
H   % vypis vypoctu jednotlivych podminek retezove stability

% podminka BD retezove stability dozadu  opak dopredne ss
for i=3:N       % vhodny rozsah   
H_zpet(i-2) = norm((Fc(sude(i-2),i)/Fc(sude(i-1),i)),Inf);  % urceni jednotlivych podminek
end
H_zpet
norma = 1;
for i=1:N-1
    norma = norma * Fc(sude(i),i);
end
HC = norm(norma)

K = -K; % pouze pro spolecne zavedeni jednoho schema v simulinku
% jinak nestabilni takto

 %% nyquistovo graf, frekv. charky
% figure;
% plot(0,'b')
% hold on;
% plot(0,'r')
% plot(0,'yellow')
% nyquist(Fc(2,1),'b')
% nyquist(Fc(4,1),'r')
% nyquist(Fc(4,1)/Fc(2,1),'yellow')
% legend('$P_{d_1\rightarrow\delta w_1} = P_1$', '$P_{d_1\rightarrow\delta w_2} = P_2$', '$Q_{1,2} = \frac{P_2}{P_1}$', 'Interpreter', 'latex')
% title('Frekvencni charakteristika prenosu z chyb na odchylky od polohy')
% % nyquist(Fc(2,2))
% % nyquist(Fc(4,1))
% % nyquist(Fc(4,2))
% % nyquist(Fc(2,3))
% % nyquist(Fc(4,3))
% % nyquist(Fc(4,1)/Fc(2,1))
% 
% % saveas(get_param('vozidla3_komplet','Handle'),'vozidla3.pdf');

%% 
if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end
poloha1 = simul.vystup1.signals.values(:,1);
rychlosti = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t = simul.tout(:);
figure;
plot(t,polohy(:,1),'blue')
hold on;
plot(t,polohy(:,2), 'red')
if N == 4
    plot(t,polohy(:,3), 'green--')
    legend('$\delta w_1$', '$\delta w_2$', '$\delta w_3$', 'Interpreter','latex')
elseif N == 5   
    plot(t,polohy(:,3), 'green--')
    plot(t,polohy(:,4), 'black-.')
    legend('$\delta w_1$', '$\delta w_2$', '$\delta w_3$', '$\delta w_4$', 'Interpreter','latex')
else
    legend('$\delta w_1$', '$\delta w_2$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od polohy kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od polohy [m]')
grid on;
xlim([t(1) t(end)]);

figure;
plot(t,rychlosti(:,1), 'blue')
hold on;
plot(t,rychlosti(:,2), 'red')
plot(t,rychlosti(:,3), 'green')
if N == 4
    plot(t,rychlosti(:,4), 'm:')
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', '$\delta y_4$', 'Interpreter','latex')
elseif N == 5
    plot(t,rychlosti(:,4), 'm:')
    plot(t,rychlosti(:,5), 'black-.')
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', '$\delta y_4$', '$\delta y_5$', 'Interpreter','latex')
else
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od rychlosti [m/s]')
grid on;
xlim([t(1) t(end)]);