%% rizeni N vozidel
clear all;close all;clc;
N = 3;      % pocet vozidel
pocet_stavu = 2*N-1;    % vypocte poce stavu v modelu
conds = [0 , 4 , 0 , 2 , 0];    % poc. podminky pro 3 vozidla
if N == 5
    conds = [0 , 4 , 0 , 3 , 0, 2, 0, -1, 0];
end

conds0 = zeros(1,2*N-1);    % nulove poc. podminky

topologie = 1;
% 1 -> PF
% 2 -> SF
% 3 -> BD

% automaticky matice A,B
A = zeros(2*N-1);
B = zeros(2*N-1,N);

for i = 1:2:(2*N-1)
   A(i,i) = -1;
   A(i+1,i) = 1;
   A(i+1,i+2) = -1;
end
for i = 1:2:(2*N-1)
    B(i,ceil(i/2)) = 1;
end
A = A(1:(2*N-1),1:(2*N-1));
C = eye(pocet_stavu);
Cy = C;
Cw = C;
Cy(2:2:pocet_stavu-1,2:2:pocet_stavu-1) = 0;
Cw(1:2:pocet_stavu,1:2:pocet_stavu) = 0;
D = zeros(pocet_stavu,N);

% rizeni dle topologie BD,PF,opak PF pro 3 auta
if N == 3
    if topologie == 1
        K = [[-1/2,-1/2,0,0,0];[3/4,3/4,-3/2,0,0];[0,0,1,1,-1]]; % PF
    elseif topologie == 2
%         K = [[0,-1/4,7/18,1/18,0];[0,0,-1,-1,7/4];[0,0,0,0,1/2]]; %SF druhy smer-opak - retez - nestab
        K = [[-1/2,-1/2,2/3,-1/3,0];[0,0,-1/2,-1/2,1];[0,0,0,0,1/2]]; % retez stabilni
    else 
%         K = [[-7/3,-8/3,4/3,-5/2,0];[2/3,4/3,-1/6,1/2,-3/2];[0,0,3/2,1/2,-5/2]]; % BD
        K = [[-4,-6,3,6,0];[-1,-2,-1,4,1];[0,0,3,12,-4]];
   end    
end

if N == 4
    if topologie == 1
%         K = 0; % PF
    elseif topologie == 2
        K = [[-2,-2,1,0,0,0,0];[0,0,-2,-2,1,0,0];[0,0,0,0,-4,-6,3];[0,0,0,0,0,0,-1]]; % SF
    else
%         K = [[-5/2,-3,7/4,1/2,0,0,0];[-1/7,-2/7,-7/2,-37/7,18/7,0,0];[0,0,-7/4,-7/2,1,1,-1/2];[0,0,0,0,2,4,-3]]; %BD
        K = [[-7/5,-4/5,4/5,4/5,0,0,0];[22/15,44/15,-34/15,2/5,1/6,0,0];[0,0,32/33,64/33,-4/3,20/33,-10/33];[0,0,0,0,2,4,-3]];   
            % nalezt lepsi reseni
    end   
end

if N == 5
    if topologie == 1
%         K = 0; % PF
    elseif topologie == 2
%         K = 0; % SF
    else
%         K = 0; %BD
    end   
end

Az = A+B*K;     % dynamika rizeneho systemu
eig(Az)         % jeji vlastni cisla
porucha = B; 

s = tf('s');
Fc = simplify(C*((s*eye(pocet_stavu)-Az)^(-1))*porucha + D);    % prenosy rizeneho sys s poruchou
 
% podminka retezove stability dopredu
a=1:2*N-1;
sude=a(mod(a,2)==0);    % sude prenosy odpovidaji z poruchy na odchylky poloh
for i=1:N-2       % vhodny rozsah   
H_r(i) = norm(simplify((Fc(sude(i+1),i)/Fc(sude(i),i))),Inf);  % urceni jednotlivych podminek
end

% podminka retezove stability dozadu -vhodnejsi- opak dopredne ss
for i=3:N       % vhodny rozsah   
H_zpet(i-2) = norm((Fc(sude(i-2),i)/Fc(sude(i-1),i)),Inf);  % urceni jednotlivych podminek
end

H_r      %vypis vycislene podminek retezove stability
H_zpet

%% grafy
if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t = simul.tout(:);
figure;
plot(t,polohy(:,1),'blue')
hold on;
plot(t,polohy(:,2), 'red')
if N == 4
    plot(t,polohy(:,3), 'green--')
    legend('$\delta w_1$', '$\delta w_2$', '$\delta w_3$', 'Interpreter','latex')
elseif N == 5   
    plot(t,polohy(:,3), 'green--')
    plot(t,polohy(:,4), 'black-.')
    legend('$\delta w_1$', '$\delta w_2$', '$\delta w_3$', '$\delta w_4$', 'Interpreter','latex')
else
    legend('$\delta w_1$', '$\delta w_2$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od polohy kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od polohy [m]')
grid on;
xlim([t(1) t(end)]);

figure;
plot(t,rychlosti(:,1), 'blue')
hold on;
plot(t,rychlosti(:,2), 'red-.')
% plot(t,rychlosti(:,3), 'green')
plot(t,rychlosti(:,3), 'green--')
if N == 4
    plot(t,rychlosti(:,4), 'm:')
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', '$\delta y_4$', 'Interpreter','latex')
elseif N == 5
    plot(t,rychlosti(:,4), 'm:')
    plot(t,rychlosti(:,5), 'black-.')
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', '$\delta y_4$', '$\delta y_5$', 'Interpreter','latex')
else
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od rychlosti [m/s]')
grid on;
xlim([t(1) t(end)]);

%% nyquistovo graf, frekv. charky - dodelat bode
figure;
plot(0,'b')
hold on;
plot(0,'r')
plot(0,'yellow')
nyquist(Fc(4,3),'b')
nyquist(Fc(2,3),'r')
nyquist(Fc(2,3)/Fc(4,3),'yellow')
legend('$P_{d_1\rightarrow\delta w_1} = P_1$', '$P_{d_1\rightarrow\delta w_2} = P_2$', '$Q_{1,2} = \frac{P_2}{P_1}$', 'Interpreter', 'latex')
title('Frekvencni charakteristika prenosu z chyb na odchylky od polohy')