%% rizeni N vozidel
clc; clear all; close all;
N = 3;  % pocet vozidel
pocet_stavu = 2*N-1;    % vypocte pocet stavu v modelu
conds = [0 , 4 , 0 , 2 , 0];
if N == 5
    conds = [0 , 4 , 0 , 2 , 0, 1, 0, -1, 0];
end
conds0 = zeros(1,2*N-1);    % nulove poc. podminky

[A,B,C,D,Az_lqr,K_lqr,H_lqr,H_zpet_lqr] = appLQR(N);
[A,B,C,D,Az_sym,K_sym,H_sym,H_zpet_sym] = appSYM(N);
eig(Az_lqr) % vlastni cisla rizeneho systemu
porucha = B; 
H_lqr   % vypis vypoctu jednotlivych podminek retezove stability
H_zpet_lqr
K = -K_lqr; % pouze pro spolecne zavedeni jednoho schema v simulinku
% jinak nestabilni takto

if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti_lqr = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy_lqr = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t = simul.tout(:);



[A,B,C,D,Az_sym,K_sym,H_sym,H_zpet_sym] = appSYM(N);
eig(Az_sym) % vlastni cisla rizeneho systemu
porucha = B; 
H_sym  % vypis vypoctu jednotlivych podminek retezove stability
H_zpet_sym
K = K_sym; % neni treba nasobit -1

if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti_sym = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy_sym = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t_sym = simul.tout(:);


[A,B,C,D,Az_dekomp,K_dekomp,H_dekomp,H_zpet_dekomp] = appDekompLQR(N);
eig(Az_dekomp) % vlastni cisla rizeneho systemu
porucha = B; 
H_dekomp  % vypis vypoctu jednotlivych podminek retezove stability
H_zpet_dekomp
K = -K_dekomp;

if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti_dekomp = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy_dekomp = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t_dekomp = simul.tout(:);
%% grafy
% if N == 3
%     simul = sim('vozidla3_komplet');
% elseif N == 4
%     simul = sim('vozidla4_komplet');
% else
%     simul = sim('vozidla5_komplet');
% end
% 
% rychlosti_lqr = simul.vystup.signals.values(:,1:2:pocet_stavu);
% polohy_lqr = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
% t = simul.tout(:);
figure;
plot(t,polohy_lqr(:,1),'blue')
hold on;
plot(t_sym,polohy_sym(:,1),'blue--')
plot(t,polohy_lqr(:,2), 'red')
plot(t_sym,polohy_sym(:,2), 'red--')
if N == 4
    plot(t,polohy_lqr(:,3), 'green')
    plot(t_sym,polohy_sym(:,3), 'green--')
    legend('$\delta w_{1,LQR}$', '$\delta w_{1,SYM}$', '$\delta w_{2,LQR}$''$\delta w_{2,SYM}$', '$\delta w_{3,LQR}$', '$\delta w_{3,SYM}$', 'Interpreter','latex')
elseif N == 5   
    plot(t,polohy_lqr(:,3), 'green')
    plot(t_sym,polohy_sym(:,3), 'green--')
    plot(t,polohy_lqr(:,4), 'black')
    plot(t_sym,polohy_sym(:,4), 'black--')
    legend('$\delta w_{1,LQR}$', '$\delta w_{1,SYM}$', '$\delta w_{2,LQR}$', '$\delta w_{2,SYM}$','$\delta w_{3,LQR}$', '$\delta w_{3,SYM}$', '$\delta w_{4,LQR}$', '$\delta w_{4,SYM}$', 'Interpreter','latex')
else
    legend('$\delta w_{1,LQR}$', '$\delta w_{1,SYM}$','$\delta w_{2,LQR}$', '$\delta w_{2,SYM}$', 'Interpreter','latex')
end


title('Prubeh regulace odchylek od polohy kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od polohy [m]')
grid on;
xlim([t(1) t(end)]);

figure;
plot(t,rychlosti_lqr(:,1), 'blue')
hold on;
plot(t_sym,rychlosti_sym(:,1), 'blue--')
plot(t,rychlosti_lqr(:,2), 'red')
plot(t_sym,rychlosti_sym(:,2), 'red--')
plot(t,rychlosti_lqr(:,3), 'green')
plot(t_sym,rychlosti_sym(:,3), 'green--')
if N == 4
    plot(t,rychlosti_lqr(:,4), 'm')
    plot(t_sym,rychlosti_sym(:,4), 'm--')
    legend('$\delta y_{1,LQR}$', '$\delta y_{1,SYM}$', '$\delta y_{2,LQR}$', '$\delta y_{2,SYM}$','$\delta y_{3,LQR}$', '$\delta y_{3,SYM}$', '$\delta y_{4,LQR}$', '$\delta y_{4,SYM}$', 'Interpreter','latex')
elseif N == 5 
    plot(t,rychlosti_lqr(:,4), 'm')
    plot(t_sym,rychlosti_sym(:,4), 'm--')
    plot(t,rychlosti_lqr(:,5), 'black')
    plot(t_sym,rychlosti_sym(:,5), 'black--')
    legend('$\delta y_{1,LQR}$', '$\delta y_{1,SYM}$', '$\delta y_{2,LQR}$', '$\delta y_{2,SYM}$', '$\delta y_{3,LQR}$','$\delta y_{3,SYM}$', '$\delta y_{4,LQR}$', '$\delta y_{4,SYM}$', '$\delta y5$', '$\delta y_5$', 'Interpreter','latex')
else 
    legend('$\delta y_{1,LQR}$', '$\delta y_{1,SYM}$', '$\delta y_{2,LQR}$','$\delta y_{2,SYM}$', '$\delta y_{3,LQR}$', '$\delta y_{3,SYM}$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od rychlosti [m/s]')
grid on;
xlim([t(1) t(end)]);
