%% rizeni N vozidel
clc; clear all; close all;
N = 3;  % pocet vozidel
pocet_stavu = 2*N-1;    % vypocte pocet stavu v modelu
conds = [0 , 4 , 0 , 2 , 0];
if N == 5
    conds = [0 , 4 , 0 , 2 , 0, 1, 0, -1, 0];
end
conds0 = zeros(1,2*N-1);    % nulove poc. podminky

%1 PF, 2 SF, 3 BD
[A,B,C,D,Az_szv,K_szv,H_szv,H_zpet_szv] = appSZV(N,1);
eig(Az_szv) % vlastni cisla rizeneho systemu
porucha = B; 
H_szv   % vypis vypoctu jednotlivych podminek retezove stability
H_zpet_szv
K = K_szv; % pouze pro spolecne zavedeni jednoho schema v simulinku
% jinak nestabilni takto

if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti_szv = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy_szv = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t = simul.tout(:);



[A,B,C,D,Az_dekomp,K_dekomp,H_dekomp,H_zpet_dekomp] = appDekompLQR(N);
eig(Az_dekomp) % vlastni cisla rizeneho systemu
porucha = B; 
H_dekomp  % vypis vypoctu jednotlivych podminek retezove stability
H_zpet_dekomp
K = -K_dekomp; % neni treba nasobit -1

if N == 3
    simul = sim('vozidla3_komplet');
elseif N == 4
    simul = sim('vozidla4_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti_dekomp = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy_dekomp = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t_dekomp = simul.tout(:);
%%
figure;
plot(t,polohy_szv(:,1),'blue')
hold on;
plot(t_dekomp,polohy_dekomp(:,1),'blue--')
plot(t,polohy_szv(:,2), 'red')
plot(t_dekomp,polohy_dekomp(:,2), 'red--')
if N == 4
    plot(t,polohy_szv(:,3), 'green')
    plot(t_dekomp,polohy_dekomp(:,3), 'green--')
    legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$', '$\delta w_{2,SZV-PF}$''$\delta w_{2,DLQR-PF}$', '$\delta w_{3,SZV-PF}$', '$\delta w_{3,DLQR-PF}$', 'Interpreter','latex')
elseif N == 5   
    plot(t,polohy_szv(:,3), 'green')
    plot(t_dekomp,polohy_dekomp(:,3), 'green--')
    plot(t,polohy_szv(:,4), 'black')
    plot(t_dekomp,polohy_dekomp(:,4), 'black--')
    legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$', '$\delta w_{2,SZV-PF}$', '$\delta w_{2,DLQR-PF}$','$\delta w_{3,SZV-PF}$', '$\delta w_{3,DLQR-PF}$', '$\delta w_{4,SZV-PF}$', '$\delta w_{4,DLQR-PF}$', 'Interpreter','latex')
else
    legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$','$\delta w_{2,SZV-PF}$', '$\delta w_{2,DLQR-PF}$', 'Interpreter','latex')
end


title('Porovnani prubehu regulace odchylek od polohy kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od polohy [m]')
grid on;
xlim([t(1) t(end)]);

figure;
plot(t,rychlosti_szv(:,1), 'blue')
hold on;
plot(t_dekomp,rychlosti_dekomp(:,1), 'blue--')
plot(t,rychlosti_szv(:,2), 'red')
plot(t_dekomp,rychlosti_dekomp(:,2), 'red--')
plot(t,rychlosti_szv(:,3), 'green')
plot(t_dekomp,rychlosti_dekomp(:,3), 'green--')
if N == 4
    plot(t,rychlosti_szv(:,4), 'm')
    plot(t_dekomp,rychlosti_dekomp(:,4), 'm--')
    legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$', '$\delta y_{2,DLQR-PF}$','$\delta y_{3,SZV-PF}$', '$\delta y_{3,DLQR-PF}$', '$\delta y_{4,SZV-PF}$', '$\delta y_{4,DLQR-PF}$', 'Interpreter','latex')
elseif N == 5 
    plot(t,rychlosti_szv(:,4), 'm')
    plot(t_dekomp,rychlosti_dekomp(:,4), 'm--')
    plot(t,rychlosti_szv(:,5), 'black')
    plot(t_dekomp,rychlosti_dekomp(:,5), 'black--')
    legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$', '$\delta y_{2,DLQR-PF}$', '$\delta y_{3,SZV-PF}$','$\delta y_{3,DLQR-PF}$', '$\delta y_{4,SZV-PF}$', '$\delta y_{4,DLQR-PF}$', '$\delta y5$', '$\delta y_5$', 'Interpreter','latex')
else 
    legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$','$\delta y_{2,DLQR-PF}$', '$\delta y_{3,SZV-PF}$', '$\delta y_{3,DLQR-PF}$', 'Interpreter','latex')
end
title('Porovnani prubehu regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [s]')
ylabel('odchylka od rychlosti [m/s]')
grid on;
xlim([t(1) t(end)]);
%% subploty
figure;

subplot(2,1,1);
plot(t,polohy_szv(:,1),'blue')
hold on;
grid on;
plot(t,polohy_szv(:,2), 'red')
legend('$\delta w_{1,SZV-PF}$','$\delta w_{2,SZV-PF}$', 'Interpreter','latex')
subplot(2,1,2);
plot(t_dekomp,polohy_dekomp(:,1),'blue')
hold on;
plot(t_dekomp,polohy_dekomp(:,2), 'red')
legend('$\delta w_{1,DLQR-PF}$', '$\delta w_{2,DLQR-PF}$', 'Interpreter','latex')

% figure;
% plot(t,polohy_szv(:,1),'blue')
% hold on;
% plot(t_dekomp,polohy_dekomp(:,1),'blue--')
% plot(t,polohy_szv(:,2), 'red')
% plot(t_dekomp,polohy_dekomp(:,2), 'red--')
% if N == 4
%     plot(t,polohy_szv(:,3), 'green')
%     plot(t_dekomp,polohy_dekomp(:,3), 'green--')
%     legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$', '$\delta w_{2,SZV-PF}$''$\delta w_{2,DLQR-PF}$', '$\delta w_{3,SZV-PF}$', '$\delta w_{3,DLQR-PF}$', 'Interpreter','latex')
% elseif N == 5   
%     plot(t,polohy_szv(:,3), 'green')
%     plot(t_dekomp,polohy_dekomp(:,3), 'green--')
%     plot(t,polohy_szv(:,4), 'black')
%     plot(t_dekomp,polohy_dekomp(:,4), 'black--')
%     legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$', '$\delta w_{2,SZV-PF}$', '$\delta w_{2,DLQR-PF}$','$\delta w_{3,SZV-PF}$', '$\delta w_{3,DLQR-PF}$', '$\delta w_{4,SZV-PF}$', '$\delta w_{4,DLQR-PF}$', 'Interpreter','latex')
% else
%     legend('$\delta w_{1,SZV-PF}$', '$\delta w_{1,DLQR-PF}$','$\delta w_{2,SZV-PF}$', '$\delta w_{2,DLQR-PF}$', 'Interpreter','latex')
% end


title('Porovnani prubehu regulace odchylek od polohy kolony vozidel')
xlabel('cas [t]')
ylabel('odchylka od polohy')
grid on;
xlim([t(1) t(end)]);



figure;
subplot(2,1,1);
plot(t,rychlosti_szv(:,1), 'blue')
hold on;
grid on;
plot(t,rychlosti_szv(:,2), 'red')
plot(t,rychlosti_szv(:,3), 'green')
legend('$\delta y_{1,SZV-PF}$', '$\delta y_{2,SZV-PF}$', '$\delta y_{3,SZV-PF}$', 'Interpreter','latex')
subplot(2,1,2);
plot(t_dekomp,rychlosti_dekomp(:,1), 'blue')
hold on;
plot(t_dekomp,rychlosti_dekomp(:,2), 'red')
plot(t_dekomp,rychlosti_dekomp(:,3), 'green')
legend('$\delta y_{1,DLQR-PF}$', '$\delta y_{2,DLQR-PF}$', '$\delta y_{3,DLQR-PF}$', 'Interpreter','latex')



% figure;
% plot(t,rychlosti_szv(:,1), 'blue')
% hold on;
% plot(t_dekomp,rychlosti_dekomp(:,1), 'blue--')
% plot(t,rychlosti_szv(:,2), 'red')
% plot(t_dekomp,rychlosti_dekomp(:,2), 'red--')
% plot(t,rychlosti_szv(:,3), 'green')
% plot(t_dekomp,rychlosti_dekomp(:,3), 'green--')
% if N == 4
%     plot(t,rychlosti_szv(:,4), 'm')
%     plot(t_dekomp,rychlosti_dekomp(:,4), 'm--')
%     legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$', '$\delta y_{2,DLQR-PF}$','$\delta y_{3,SZV-PF}$', '$\delta y_{3,DLQR-PF}$', '$\delta y_{4,SZV-PF}$', '$\delta y_{4,DLQR-PF}$', 'Interpreter','latex')
% elseif N == 5 
%     plot(t,rychlosti_szv(:,4), 'm')
%     plot(t_dekomp,rychlosti_dekomp(:,4), 'm--')
%     plot(t,rychlosti_szv(:,5), 'black')
%     plot(t_dekomp,rychlosti_dekomp(:,5), 'black--')
%     legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$', '$\delta y_{2,DLQR-PF}$', '$\delta y_{3,SZV-PF}$','$\delta y_{3,DLQR-PF}$', '$\delta y_{4,SZV-PF}$', '$\delta y_{4,DLQR-PF}$', '$\delta y5$', '$\delta y_5$', 'Interpreter','latex')
% else 
%     legend('$\delta y_{1,SZV-PF}$', '$\delta y_{1,DLQR-PF}$', '$\delta y_{2,SZV-PF}$','$\delta y_{2,DLQR-PF}$', '$\delta y_{3,SZV-PF}$', '$\delta y_{3,DLQR-PF}$', 'Interpreter','latex')
% end
title('Porovnani prubehu regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [t]')
ylabel('odchylka od rychlosti')
grid on;
xlim([t(1) t(end)]);