% stary kod na strukturalni dekomp

clc;
clear all;
close all;
N = 5;
pocet_stavu = 2*N - 1;
%strukturalni dekompozice - lqr jako distribuovane rizeni
% automaticky matice A,B
A = zeros(pocet_stavu);
B = zeros(pocet_stavu,N);

conds = [0 , 4 , 0 , 2 , 0];    % poc. podminky pro 3 vozidla
if N == 5
    conds = [0 , 4 , 0 , 3 , 0, 2, 0, -1, 0];
end

conds0 = zeros(1,pocet_stavu);    % nulove poc. podminky

for i = 1:2:(pocet_stavu)
   A(i,i) = -1;
   A(i+1,i) = 1;
   A(i+1,i+2) = -1;
end
for i = 1:2:(pocet_stavu)
    B(i,ceil(i/2)) = 1;
end
A = A(1:(pocet_stavu),1:(pocet_stavu));

C = eye(pocet_stavu);
Cy = C;
Cw = C;
Cy(2:2:pocet_stavu-1,2:2:pocet_stavu-1) = 0;
Cw(1:2:pocet_stavu,1:2:pocet_stavu) = 0;
D = zeros(pocet_stavu,N);

%leader
a_lead = A(1,1);
b_lead = B(1,1);
Q_lead = 20;
R_lead = 2;
[K_lead,~,~] = lqr(a_lead,b_lead,Q_lead,R_lead);
K_lead1 = [K_lead,0,0];
sys0 = ss(a_lead,b_lead,1,0)
ABk_lead = a_lead - b_lead*K_lead1;

Ko = zeros(N,pocet_stavu);
Ko(1,1) = K_lead;
ai = A(1:3,1:3);
bi = B(1:3,1);
Bi = B(3:5,3);
Qi = zeros(3);
Qi(2,2) = 20;
Ri = 2;
odkud = 1;
kam = odkud+2;
for i=2:N
    i
    odkud
    kam
    if i == 2
      Abk = ai - bi*Ko(i-1,odkud:kam) ;   
    else
      Abk = ai - bi*Ko(i-1,odkud-2:kam-2); 
    end
    [K1o,~,~] = lqr(Abk,Bi,Qi,Ri);
    Ko(i,odkud:kam) = K1o(:);
%     clear K1o
    
    odkud = kam;
    kam = kam+2;
end

%vehicle1
a1 = A(1:3,1:3);
b1 = B(1:3,1);
K_lead1 = [K_lead,0,0];
ABk1 = a1 - b1*K_lead1;
B1 = B(1:3,2);
sys1 = ss(a1,b1,eye(3),zeros(3,1));

Q1 = zeros(3);
Q1(2,2) = 20;
R1 = 2;
[K1,~,~] = lqr(ABk1,B1,Q1,R1)

%vehicle2
a2 = A(3:5,3:5);
b2 = B(3:5,2);
% K_lead1 = [K_lead,0,0];
ABk2 = a2 - b2*K1;
B2 = B(3:5,3);
sys2 = ss(a2,b2,eye(3),eye(3,1));

% Q1 = zeros(3);
% Q1(2,2) = 20;
% R1 = 2;
[K2,~,~] = lqr(ABk2,B2,Q1,R1);

%vehicle3
a3 = A(5:7,5:7);
b3 = B(5:7,3);
% K_lead1 = [K_lead,0,0];
ABk3 = a3 - b3*K2;
B3 = B(5:7,4);
sys3 = ss(a3,b3,eye(3),eye(3,1));

% Q1 = zeros(3);
% Q1(2,2) = 20;
% R1 = 2;
[K3,~,~] = lqr(ABk3,B3,Q1,R1);
K = zeros(N,pocet_stavu);
K(1,1) = K_lead;
K(2,1:length(K1)) = K1;
K(3,length(K1):length(K1)+2) = K2;
K(4,length(K2)+2:end) = K3;
Az = A-B*K;     % dynamika rizeneho systemu
eig(Az);         % jeji vlastni cisla
porucha = B; 

s = tf('s');
Fc = simplify(C*((s*eye(pocet_stavu)-Az)^(-1))*porucha + D);    % prenosy rizeneho sys s poruchou
 
% podminka retezove stability
a=1:2*N-1;
sude=a(mod(a,2)==0);    % sude prenosy odpovidaji z poruchy na odchylky poloh
for i=1:N-2       % vhodny rozsah   
H(i) = norm((Fc(sude(i+1),i)/Fc(sude(i),i)),Inf);  % urceni jednotlivych podminek
end

liche=a(mod(a,2)==1);       % liche prenosy odpovidaji z poruchy na odchylky rychlosti
for i=1:N-1           
Hy(i) = norm((Fc(liche(i+1),i)/Fc(liche(i),i)),Inf);    % vzdy jednicky
end
H      %vypis vycislene podminek retezove stability

K = -K;
Ko = -Ko;
%% grafy
if N == 3
    simul = sim('vozidla3_komplet');
else
    simul = sim('vozidla5_komplet');
end

rychlosti = simul.vystup.signals.values(:,1:2:pocet_stavu);
polohy = simul.vystup.signals.values(:,2:2:pocet_stavu-1);
t = simul.tout(:);
figure;
plot(t,polohy(:,1),'blue')
hold on;
plot(t,polohy(:,2), 'red')
if N == 5   
    plot(t,polohy(:,3), 'green--')
    plot(t,polohy(:,4), 'black-.')
    legend('$\delta w_1$', '$\delta w_2$', '$\delta w_3$', '$\delta w_4$', 'Interpreter','latex')
else
    legend('$\delta w_1$', '$\delta w_2$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od polohy kolony vozidel')
xlabel('cas [t]')
ylabel('odchylka od polohy')
grid on;
xlim([t(1) t(end)]);

figure;
plot(t,rychlosti(:,1), 'blue')
hold on;
plot(t,rychlosti(:,2), 'red-.')
% plot(t,rychlosti(:,3), 'green')
plot(t,rychlosti(:,3), 'green--')
if N == 5
    plot(t,rychlosti(:,4), 'm:')
    plot(t,rychlosti(:,5), 'black-.')
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', '$\delta y_4$', '$\delta y_5$', 'Interpreter','latex')
else
    legend('$\delta y_1$', '$\delta y_2$', '$\delta y_3$', 'Interpreter','latex')
end
title('Prubeh regulace odchylek od rychlosti kolony vozidel')
xlabel('cas [t]')
ylabel('odchylka od rychlosti')
grid on;
xlim([t(1) t(end)]);